#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 2e6 + 1;

bool cmp(pair<int,int>a, pair<int,int>b){
    return a.second < b.second;
}

void solve(){
    int n;
    cin >> n;
    vector<pair<int,int>>a(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.rbegin(), a.rend());
    vector<int>e(N, 1);
    e[1] = 0;
    for(int i = 2; i < N; ++i){
        for(int j = 2 * i; j < N; j += i){
            e[j] = 0;
        }
    }
    vector<int>color(N, 0);
    color[1] = 1;
    for(auto & [x, type] : a){
        vector<int>b(3);
        //cout << x << ' ';
        for(int j = 1; j * j <= x; ++j){
            if(x % j == 0){
                int v = x / j;
                if(e[v]) b[color[j]]++;
                else if(e[j]) b[color[v]]++;
            }
        }
        int mx = -1, t = 0;
        for(int j = 1; j < 3; ++j){
            if(mx <= b[j]){
                mx = b[j];
                t = j;
            }
        }

        if(t == 0) t = 1;
        //cout << t << ' ' << mx << '\n';
        color[x] = (t == 2 ? 1 : 2);
    }
    sort(a.begin(), a.end(), cmp);
    for(int i = 0; i < n; ++i){
        cout << color[a[i].first] << ' ';
    }

}

signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int test = 1;
    solve();
}
