#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 2e6 + 1;

vector<vector<int>>g(N);
vector<int>type(N, -1);
vector<int>ord;

void dfs(int v, int pr = -1){
    int cnt = 0;
    for(auto &i : g[v]){
        if(i == pr) continue;
        if(type[v] == -1){
            ord.push_back(v);
            dfs(i, v);
        }
        if(type[v] == 0){
            dfs(i, v);
            if(cnt == 0){
                ord.push_back(v);
                ++cnt;
            }


        }
        if(type[v] == 1){
            dfs(i, v);
        }
    }
    if(type[v] == 1) ord.push_back(v);
}

void solve(){
    int n, q;
    cin >> n >> q;
    for(int i = 0; i < n; ++i){
        int l, r;
        cin >> l >> r;
        --l, --r;
        if(l >= 0){
            g[i].push_back(l);
            g[l].push_back(i);
        }
        if(r >= 0){
            g[r].push_back(i);
            g[i].push_back(r);
        }
    }
    dfs(0);
    while(q--){
        int t, l, r;
        cin >> t;
        if(t == 1){
            cin >> l >> r;
            --l, --r;
            int c;
            cin >> c;
            for(int i = l; i <= r; ++i) type[i] = c;
            ord.clear();
            dfs(0);
        } else {
            int u;
            cin >> u;
            --u;
            cout << ord[u] << '\n';
        }
    }

}

signed main() {
    ios_base ::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int test = 1;
    solve();
}
